<?php
class SPEClass{

    private static $instance;
    private function __construct() { } 
    private function __clone(){} 
    
 
    public static function getInstance (){
        if (self::$instance === null) {
            self::$instance = new SPEClass();
        }
        return self::$instance;
 
        return (self::$instance === null) ? self::$instance = new SPEClass() : self::$instance;
    }
    
    public function editHeader(){
        //extrabrowser is loaded no matter its used or not
        ?>
            <link rel="stylesheet" href="../plugins/SpecialPagesExtras/css/extraBrowser.css" />
            <link rel="stylesheet" href="../plugins/SpecialPagesExtras/css/edit.css" />
            <script type="text/javascript" src="../plugins/SpecialPagesExtras/js/jquery-ui.sort.min.js"></script>
            <script type="text/javascript" src="../plugins/SpecialPagesExtras/js/jquery.extraBrowser.js"></script>
        <?php
    }
    
    public function editExtras($specialName){
        $settings = $this->loadSpecialPageSettings($specialName);

        if (empty($settings))
            return;
            
        $pageData = @$settings['pageData'];
        $fieldsData = @$settings['fieldsData'];
        
        $imageFieldNames = array(); //standard image fields
        $hasImageWithThumbsFields = false;
        
        require_once(GSPLUGINPATH.'i18n_specialpages/specialpages.class.php');
        $specialSettings = I18nSpecialPages::getSettings($specialName);
        
        //if extra browser is on, then find all fields that has type of image and pass it to JS
        if (@$pageData['extra-browser']){ //silent error, for old versions that do not have tihs settings
            
            for ($i = 0; $i < count($specialSettings['fields']); $i++) {
                $field = $specialSettings['fields'][$i];
                if ($field['type'] == 'image')
                    $imageFieldNames[] = array('name' => strtolower($field['name']), 'index' => $i + 1); //lower is must have, +1 is to match specialepages edit.php
            }
        }
        
        if ($fieldsData){
            foreach ($fieldsData as $name => $data) {
                if ($data['new-type'] == 'imagewiththumb')
                    $hasImageWithThumbsFields = true;
            }
        }

        include('views/editScripts.php'); //include all js 
        
        if (@$pageData['extra-browser'] && (count($imageFieldNames) || $hasImageWithThumbsFields))
            include('views/extraBrowser.html'); //include extraBrowseer
    }  


    public function confHeader(){
        ?>
            <link rel="stylesheet" href="../plugins/SpecialPagesExtras/css/configure.css" />
        <?php
    }
    
    //used when GS deletes file from uploads, delete cached thumb
    public function onFileDelete(){    
        $path = (isset($_GET['path'])) ? $_GET['path'] : '';
        $id = $_GET['file'];            
        $filepath = GSDATAUPLOADPATH . $path;
        $file =  $filepath . $id;
        
        $uploadsDirPart = str_replace(GSDATAPATH, '', GSDATAUPLOADPATH); //find name of uploads subdir
        $thumbsDirPart = str_replace(GSDATAPATH, '', GSTHUMBNAILPATH); //find name of uploads subdir

        //check that path is safe, etc.
        if(path_is_safe($filepath,GSDATAUPLOADPATH) && filepath_is_safe($file,$filepath)){
            //delete from uploads image,  thumb
            @unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/extra-browser-thumbs/'.$uploadsDirPart.$path . $id);
            @unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/image-field-thumbs/'.$uploadsDirPart.$path . $id);
            @unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/multi-image-thumbs/'.$uploadsDirPart.$path . $id);
      
            //delete thumb for thumbnail 
            @unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/extra-browser-thumbs/'.$thumbsDirPart.$path . 'thumbnail.'.$id);
            @unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/image-field-thumbs/'.$thumbsDirPart.$path . 'thumbnail.'.$id);
            @unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/multi-image-thumbs/'.$thumbsDirPart.$path . 'thumbnail.'.$id);
        }	
    }
    
    //used when GS deletes empty folder from uploads
    public function onFolderDelete(){
        $path = (isset($_GET['path'])) ? $_GET['path'] : '';
        $folder = $_GET['folder'];
        $target = GSDATAUPLOADPATH . $path . $folder;
        
        $uploadsDirPart = str_replace(GSDATAPATH, '', GSDATAUPLOADPATH); //find name of uploads subdir
        
        //check that path is safe for uploads
        if (path_is_safe($target,GSDATAUPLOADPATH)) {
       
            //removes empty directory, so we believe that all thumbs from that dir was deleted when user deleted files by admin panel
            @rmdir(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/extra-browser-thumbs/'.$uploadsDirPart.$path . $folder);
            @rmdir(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/image-field-thumbs/'.$uploadsDirPart.$path . $folder);
            @rmdir(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/multi-image-thumbs/'.$uploadsDirPart.$path . $folder);
        }
    }
   
    //work after all scripts
    public function confFooter(){

        if (!isset($_GET['copy'])) //copying old, load copy source settings
            $pageName = isset($_GET['edit']) ? $_GET['edit'] : $_POST['post-name']; //might be new one or eiditng old one
        else
            $pageName = @$_GET['copy'];
            
        $settings = $this->loadSpecialPageSettings($pageName); 
        
        $pageData = @$settings['pageData'];
        $fieldsData = @$settings['fieldsData'];
        
        require('views/confScripts.php'); //include all js 
        require('views/confDialogs.html'); //include dialogs html  
    }
    
    //save settings
    public function confSave(){        
        $fieldsData = array();

        for ($i=0; isset($_POST['cf_'.$i.'_name']); $i++) {
            $name = strtolower($_POST['cf_'.$i.'_name']); //all names are used in lowercase but sotred in i18special pages as not touched, weird 
        
            if ($name == ''){ //empty names are removes by special pages core and page settings is saved, also removes last line hidden
                continue;
            }
        
            $a = array(
                'name' => $name,
				
                //supress errors, no javascript = empty vars
                'required' => @$_POST['spe_field-'.$i.'-required'] ? 1 : '',
                'description' => @$_POST['spe_field-'.$i.'-description'],
                'new-type' => $_POST['spe_field-'.$i.'-new-type']
            );
			
			$type = $a['new-type'] ? $a['new-type'] : $_POST['cf_'.$i.'_type'];
            //store extra params for special types

            switch ($type) { //type or new type
				case 'multiselect':{
					$a['options'] = implode('||', preg_split("/\r?\n/", rtrim($_POST['cf_'.$i.'_options']))); //store options
				}
   				case 'text':
				case 'textfull':
				case 'textarea':
				case 'multiselect':
				case 'multitext':{
                    $a['regex'] = @$_POST['spe_field-'.$i.'-regex'];
					
					//here is validation of php regullar expression passed from html form
					if (@preg_match($a['regex'], "Lorem ipsum") === false)
						$a['regex'] = ''; //reset to empty
						
                    break;
                }	
				case 'multiimage':
				case 'imagewiththumb':{
					$aw = (int)$_POST['spe_field-'.$i.'-aspect-ratio-width'];
					$ah = (int)$_POST['spe_field-'.$i.'-aspect-ratio-height'];
					
					if ($aw <= 0 || $ah <= 0){ //reset if invalid
						$aw = $ah = '';
					}
					
					$a['aspect-ratio-width'] = $aw; 
					$a['aspect-ratio-height'] = $ah; 
					$a['width-comparator'] = $_POST['spe_field-'.$i.'-width-comparator'];
					$a['width'] = (int)$_POST['spe_field-'.$i.'-width'] > 0 ? (int)$_POST['spe_field-'.$i.'-width']: '';	
					$a['height-comparator'] = $_POST['spe_field-'.$i.'-height-comparator'];
					$a['height'] = (int)$_POST['spe_field-'.$i.'-height'] > 0 ? (int)$_POST['spe_field-'.$i.'-height']: '';
                    break;
                }
            }
            
            $fieldsData[] = $a; //add to array
        }
        
        $this->_confWrite($fieldsData);
    }
    
    public function confUndo(){
        $name = preg_match('/^[A-Za-z0-9-]+$/', @$_GET['edit']) ? $_GET['edit'] : null;
        $newname = @$_GET['new'];
    
        //supress errors, no extra data
        @unlink(GSDATAOTHERPATH.'i18n_special-' . $newname . '-extras.xml'); //delete old
        @copy(GSBACKUPSPATH.'other/i18n_special-' . $name . '-extras.xml', GSDATAOTHERPATH.'i18n_special-' . $name . '-extras.xml');
    }
    
    
    public function confDelete(){
        $name = $_GET['delete']; 
         //supress errors, no extra data
        @copy(GSDATAOTHERPATH.'i18n_special-' . $name . '-extras.xml', GSBACKUPSPATH.'other/i18n_special-' . $name . '-extras.xml');
        @unlink(GSDATAOTHERPATH . 'i18n_special-' . $name . '-extras.xml');
    }


    public function loadSpecialPageSettings($pageName){
        $ret = array();
    
        $xml = getXML(GSDATAOTHERPATH.'i18n_special-' . $pageName . '-extras.xml');       
     
        //parse data from settings
        if ($xml){
            foreach ($xml->page->children() as $pageSetting)
            {
                $name = $pageSetting->getName();
                $ret['pageData'][$name] = (string)$pageSetting;
            }     

            foreach ($xml->fields->children() as $field)
            {      
                $fieldsData[] = array();
            
                foreach ($field->children() as $fieldSetting)
                {               
                    $fieldName = $fieldSetting->getName();
					
					if(//not empty and of int type cast to int for json
						(string)$fieldSetting && 
						in_array( $fieldName, array('aspect-ratio-width', 'aspect-ratio-height', 'width', 'height') )
					){
						$ret['fieldsData'][(string)$field->name][$fieldName] = (int)(string)$fieldSetting;
					}
					else
						$ret['fieldsData'][(string)$field->name][$fieldName] = (string)$fieldSetting;
                }
            }
        }
        
        return empty($ret) ? null : $ret;
    }

    //writes xml data
    private function _confWrite($fieldsData){    
        $data = @new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><extras></extras>');
        $page = $data->addChild('page');
        
        $page->addChild('type-show', isset($_POST['spe_page-type-show']) ? 1 : '');
        $page->addChild('options-show', isset($_POST['spe_page-options-show']) ? 1 : '');
        
        $page->addChild('title-label-show', isset($_POST['spe_page-title-label-show']) ? 1 : '');
        $page->addChild('title-label')->addCData($_POST['spe_page-title-label']);
		
		//title regex
		$titleRegex = $_POST['spe_page-title-regex'];
		if (@preg_match($titleRegex, "Lorem ipsum") === false)
			$titleRegex = ''; //reset to empty
        $page->addChild('title-regex')->addCData($titleRegex);
		
        $page->addChild('content-hide', isset($_POST['spe_page-content-hide']) ? 1 : '');
        $page->addChild('content-label-show', isset($_POST['spe_page-content-label-show']) ? 1 : '');
        $page->addChild('content-label')->addCData($_POST['spe_page-content-label']);
        $page->addChild('content-required', isset($_POST['spe_page-content-required']) ? 1 : '');
        $page->addChild('tags-hide', isset($_POST['spe_page-tags-hide']) ? 1 : '');
        $page->addChild('meta-description-hide', isset($_POST['spe_page-meta-description-hide']) ? 1 : '');
        $page->addChild('extra-browser', isset($_POST['spe_page-extra-browser']) ? 1 : '');
        
        $fields = $data->addChild('fields');
        
        for ($i = 0; $i < count($fieldsData); $i++){
            $f = $fields->addChild('field');
            
            //iterate over params and add to xml
            foreach ($fieldsData[$i] as $key => $value){
                $f->addChild($key)->addCData($value);
            }
        }
        
        //store backup
        $oldName = @$_GET['edit'];
        
        if ($oldName && file_exists(GSDATAOTHERPATH . 'i18n_special-' . $oldName . '-extras.xml')) {
            @copy(GSDATAOTHERPATH . 'i18n_special-' . $oldName . '-extras.xml', GSBACKUPSPATH . 'other/i18n_special-' . $oldName . '-extras.xml'); //create copy
            @unlink(GSDATAOTHERPATH . 'i18n_special-' . $oldName . '-extras.xml'); //delete old
        }
        
        //name must be with minus char not underscore to not be identified as special page type file
        XMLsave($data, GSDATAOTHERPATH . 'i18n_special-' . $_POST['post-name'] . '-extras.xml');
         
    }
    
    

}